openerp.eiru_reports = function (instance) {
    "use strict";

    var reporting = instance.eiru_reports;

    reporting_base(instance,reporting);
    configuration_reporting(reporting,instance,reporting);

    try {
        /*
        ================================
            BASE
        ================================
        */
        pdf(reporting);
        chart(reporting);
        datepicker(reporting);
        /*
        ================================
            COMPRAS
        ================================
        */
        report_purchase(reporting);
        report_purchase_analytic(reporting);
        report_supplier(reporting);
        report_supplier_ranking(reporting);
        /*
        ================================
            VENTAS
        ================================
        */
        report_sale(reporting);
        report_sale_analytic(reporting);
        report_sale_baco_analytic(reporting);
        report_customer(reporting);
        report_customer_ranking(reporting);
        report_sale_ranking_product(reporting);
        report_product_list(reporting);
        /*
        ================================
            GASTOS
        ================================
        */
        report_expense(reporting);
        report_expense_analytic(reporting);
        /*
        ================================
            STOCK
        ================================
        */
        report_stock_valuation(reporting);
        report_stock_history(reporting);
        report_stock_movement(reporting);
        /*
        ================================
            FINANZAS
        ================================
        */
        report_profit_and_loss(reporting);
        report_sale_gross(reporting);
        report_sale_utility_analytic(reporting);
        report_daily_sale(reporting);
        report_income_summary(reporting);
        report_outcome_summary(reporting);
        report_sale_summary(reporting);
        report_account_receivable(reporting);
        report_account_payable(reporting);
        report_account_payable_expenses(reporting);
        report_dues_analysis(reporting);
        report_duessupplier_analysis(reporting);
        report_customer_payment(reporting);
        report_supplier_payment(reporting);
        report_customer_paymentespecial(reporting);
        report_customer_refund(reporting);
        report_supplier_refund(reporting);
        report_customer_ratings(reporting)
        /*
        ================================
            CONTABILIDAD
        ================================
        */
        // report_sale_journal(reporting);
        // report_purchase_journal(reporting);
        report_purchase_journal_detallado(reporting);
        report_sale_journal_detallado(reporting);

    } catch (e) {
        // ignorar error
    }

    /*
    ================================================================================
        PANTALLA DE BIENVENIDA
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.welcome_action', 'instance.eiru_reports.ReportingWidget');

    /*
    ================================================================================
        HISTORICO DE COMPRAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.purchase_action', 'instance.eiru_reports.ReportPurchaseWidget');

    /*
    ================================================================================
        ANALISIS DE COMPRAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.purchase_analytic_action', 'instance.eiru_reports.ReportPurchaseAnalyticWidget');

    /*
    ================================================================================
        PROVEEDORES
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.supplier_action', 'instance.eiru_reports.ReportSupplierWidget');

    /*
    ================================================================================
        RANKING DE PROVEEDORES
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.supplier_ranking_action', 'instance.eiru_reports.ReportSupplierRankingWidget');

    /*
    ================================================================================
        HISTORICO DE VENTAS
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.sale_action', 'instance.eiru_reports.ReportSaleWidget');

    /*
    ================================================================================
        ANALISIS DE VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_analytic_action', 'instance.eiru_reports.ReportSaleAnalyticWidget');

    /*
    ================================================================================
        ANALISIS DE VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_baco_analytic_action', 'instance.eiru_reports.ReportSaleBacoAnalyticWidget');

    /*
    ================================================================================
        CLIENTES
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.customer_action', 'instance.eiru_reports.ReportCustomerWidget');

    /*
    ================================================================================
        RANKING DE CLIENTES
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.customer_ranking_action', 'instance.eiru_reports.ReportCustomerRankingWidget');

    /*
    ================================================================================
        RANKING DE PRODUCTOS MAS VENDIDOS
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.sale_ranking_product_action', 'instance.eiru_reports.ReportSaleRankingProductWidget');

    /*
    ================================================================================
        HISTORICO GASTOS
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.expense_action', 'instance.eiru_reports.ReportExpenseWidget');

    /*
    ================================================================================
        ANALISIS DE GASTOS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.expense_analytic_action', 'instance.eiru_reports.ReportExpenseAnalyticWidget');

    /*
    ================================================================================
        VALORACION DE INVENTARIO
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.stock_valuation_action', 'instance.eiru_reports.ReportStockValuationWidget');

    /*
    ================================================================================
        MOVIMIENTO DE INVENTARIO
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.stock_movement_action', 'instance.eiru_reports.ReportStockMovementWidget');

    //  HISTORIAL DE INVENTARIO
    instance.web.client_actions.add('eiru_reports.stock_history_action', 'instance.eiru_reports.ReportStockHistoryWidget');

    /*
    ================================================================================
        UTILIDAD DE VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.profit_and_loss_action', 'instance.eiru_reports.ReportProfitAndLossWidget');

    /*
    ================================================================================
        UTILIDAD DE VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_gross_action', 'instance.eiru_reports.ReportSaleGrossWidget');

    /*
    ================================================================================
        ANALISIS DE UTILIDAD VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_utility_analytic_action', 'instance.eiru_reports.ReportSaleUtilityAnalyticWidget');

    //  RESUMEN DE VENTAS DIARIAS
    instance.web.client_actions.add('eiru_reports.daily_sale_action', 'instance.eiru_reports.ReportDailySaleWidget');

    /*
    ================================================================================
        RESUMEN DE INGRESOS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.income_summary_action', 'instance.eiru_reports.ReportIncomeSummaryWidget');

    //  RESUMEN DE EGRESOS
    instance.web.client_actions.add('eiru_reports.outcome_summary_action', 'instance.eiru_reports.ReportOutcomeSummaryWidget');

    /*
    ================================================================================
        RESUMEN DE VENTAS
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_summary_action', 'instance.eiru_reports.ReportSaleSummaryWidget');

    /*
    ================================================================================
        CUENTAS A COBRAR
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.account_receivable_action', 'instance.eiru_reports.ReportAccountReceivableWidget');

    //  CUENTAS A PAGAR COMPRA
    instance.web.client_actions.add('eiru_reports.account_payable_action', 'instance.eiru_reports.ReportAccountPayableWidget');
    //  CUENTAS A PAGAR GASTOS
    instance.web.client_actions.add('eiru_reports.account_payable_expenses_action', 'instance.eiru_reports.ReportAccountPayableExpensesWidget');

    //  ANALISIS DE CUOTAS
    instance.web.client_actions.add('eiru_reports.dues_analysis_action', 'instance.eiru_reports.ReportDuesAnalysisWidget');

    //  ANALISIS DE CUOTAS A PAGAR
    instance.web.client_actions.add('eiru_reports.duessupplier_analysis_action', 'instance.eiru_reports.ReportDuesSupplierAnalysisWidget');

    /*
    ================================================================================
        PAGOS DE CLIENTES
    ================================================================================
    */
    instance.web.client_actions.add('eiru_reports.customer_payment_action', 'instance.eiru_reports.ReportCustomerPaymentWidget');

    //  PAGOS A PROVEEDORES
    instance.web.client_actions.add('eiru_reports.supplier_payment_action', 'instance.eiru_reports.ReportSupplierPaymentWidget');

    //  PAGOS DE CLIENTES Y NOTA DE CREDITO
    instance.web.client_actions.add('eiru_reports.customer_paymentespecial_action', 'instance.eiru_reports.ReportCustomerPaymentEspecialWidget');

    //    NOTAS DE CREDITO
    instance.web.client_actions.add('eiru_reports.customer_refund_action', 'instance.eiru_reports.ReportCustomerRefundWidget');

    //    NOTAS DE DEBITO
    instance.web.client_actions.add('eiru_reports.supplier_refund_action', 'instance.eiru_reports.ReportSupplierRefundWidget');

    //LISTA DE PRODUCTOS
    instance.web.client_actions.add('eiru_reports.product_list_action', 'instance.eiru_reports.ReportProductListWidget');

    //LISTA DE MOROSOS
    instance.web.client_actions.add('eiru_reports.customer_ratings_action', 'instance.eiru_reports.ReportCustomerRatingsWidget');



    /*
    ================================================================================
        LIBRO DE VENTAS
    ================================================================================
     */
    // instance.web.client_actions.add('eiru_reports.sale_journal_action', 'instance.eiru_reports.ReportSaleJournalWidget');

    /*
    ================================================================================
        LIBRO DE COMPRAS
    ================================================================================
     */
    // instance.web.client_actions.add('eiru_reports.purchase_journal_action', 'instance.eiru_reports.ReportPurchaseJournalWidget');

    /*
    ================================================================================
        LIBRO DE COMPRAS DETALLADO
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.purchase_journal_detallado_action', 'instance.eiru_reports.ReportPurchaseJournalDetalladoWidget');

    /*
    ================================================================================
        LIBRO DE VENTAS DETALLADO
    ================================================================================
     */
    instance.web.client_actions.add('eiru_reports.sale_journal_detallado_action', 'instance.eiru_reports.ReportSaleJournalDetalladoWidget');

}
