function report_dues_analysis(reporting){
  "use strict";
  var model = openerp;

    reporting.ReportDuesAnalysisWidget = reporting.Base.extend({
        template: 'ReportDuesAnalysis',
        rowsData :[],
        content :[],
        modules: ['eiru_account_interest'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModel : function(model){
          var self = this;
          return _.filter(self.IrModuleModule,function(item){
            return item.name === model
          });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        clickAnalysisDetail : function(e, row, $element, field){
            if(field == 'invoice'){
                this.do_action({
                    name : 'Factura',
                    type : 'ir.actions.act_window',
                    res_model : 'account.invoice',
                    views : [[false,'form']],
                    target  : 'new',
                    domain : [['id','=',row.invoice_id]],
                    context : {},
                    flags : {'form' : {'action_buttons' : false, 'options' : {'mode' : 'view'}}},
                    res_id : row.invoice_id,
                });
            }
            e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser;
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                if(AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                    _.each(AccountJournal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchAccountInvoice().then(function(AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountMoveLine();
            }).then(function (AccountMoveLine){
                self.AccountMoveLine = AccountMoveLine;
                return self.fetchAccountInterest();
            }).then(function(AccountInterest){
                self.AccountInterest = AccountInterest;
                return self.fetchAccountInterestLine();
            }).then(function(AccountInterestLine){
                self.AccountInterestLine = AccountInterestLine;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
              defer.resolve(results);
            })
            return defer;
        },

        fetchAccountInterest:function(){
          var self = this;
          var defer = $.Deferred();
          var field =['id', 'invoice_id','lines_ids','state'];
          var domain=[['state','=','lines_open']];
          var modules = self.checkModel('eiru_account_interest');
          if (modules.length > 0){
            var AccountInterest = new model.web.Model('account.interest');
            AccountInterest.query(field).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
          }else{
              var AccountInterest = [];
              return AccountInterest;
          }
        },

        fetchAccountInterestLine:function(){
          var self = this;
          var defer = $.Deferred();
          var field =['id', 'move_line_id','amount_interest','state'];
          var domain=[['state','=','open']];
          var modules = self.checkModel('eiru_account_interest');
          if (modules.length > 0){
            var AccountInterestLine = new model.web.Model('account.interest.line');
            AccountInterestLine.query(field).filter(domain).all().then(function (results) {
              defer.resolve(results);
            });
            return defer;
          }else{
              var AccountInterestLine = [];
              return AccountInterestLine;
          }
        },

        /*
        =====================================================================
            USER
        =====================================================================
        */
        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        /*
        =====================================================================
            ACCOUNT PERIOD
        =====================================================================
        */
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var field =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');
            AccountPeriod.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        /*
        ====================================================================
            RES STORE
        ====================================================================
        */
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /*
        ====================================================================
            ACCOUNT JOURNAL
        ====================================================================
        */
        fetchAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var company = $('#current-company').val();
            var store = $('#current-store').val();
            var domain = [['active','=',true],['type','=','sale']];
            if(company && company != 9999999){
                domain.push(['company_id','=',parseFloat(company)]);
            }
            if(store && store != 9999999){
                domain.push(['store_ids','=',parseFloat(store)]);
            }
            var field = ['id', 'name','store_ids'];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /*
        ====================================================================
            ACCOUNT INVOICE
        ====================================================================
        */
        fetchAccountInvoice: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            var journal = self.$el.find('#current-journal').val();
            if(store && store != 9999999){
                var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                    return item.store_ids == store;
                }), function(map){
                    return map.id;
                });
            }else{
                var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                    return item.id;
                }));
            }
            var domain = [
                ['state', 'in',['open']],
                ['type', '=', 'out_invoice'],
                ['journal_id','in',journal_ids],
            ];
            if(journal && journal != 9999999){
                domain.push(['journal_id','=',parseInt(journal)]);
            }
            var AccountInvoice = new model.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoice',[domain], {
                context: new model.web.CompoundContext()
            });
        },
        /*
        ====================================================================
            ACCOUNT INVOICE LINE
        ====================================================================
        */
        fetchAccountMoveLine: function (){
            var self = this;
            var invoice_numbers = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.number;
            }));
            var domain = [
                ['move_id','in',invoice_numbers],
                ['debit','>',0],
                ['date_maturity','!=', false]
            ];

            var AccountMoveLine = new model.web.Model('account.move.line');
            return AccountMoveLine.call('getAccountMoveLine',[domain], {
                context: new model.web.CompoundContext()
            });
        },
        /*
        ====================================================================
            RES COMPANY
        ====================================================================
        */
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /*
        ====================================================================
            RES CURRENCY
        ====================================================================
        */
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*
        ====================================================================
            UPDATE SELECTIONS
        ====================================================================
        */
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_ids){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updatePeriodSelections: function () {
            var self = this;
            var period = self.$el.find('#current-period').val();
            if(period != 9999999){
                self.$el.find('#current-date').val(9999999);
                self.$el.find('#current-date').prop('disabled','disabled');
                self.$el.find('.datepicker').css('display','none');
            }else{
                self.$el.find('#current-date').prop('disabled',false);
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        // get due interest

        getDueInterest: function (id) {
            var self = this;
            var AccountInterestLine = self.AccountInterestLine;
            if(AccountInterestLine.length > 0){
              var interes = _.map(_.filter(AccountInterestLine,function (item) {
                  return item.move_line_id[0] === id;
              }), function(map){
                  return map.amount_interest;
              });
              if(interes.length > 0){
                return interes[0]
              }
              else{
                return 0;
              }

            }
            else{
              return 0;
            }
        },

        // get invoice interest
        getInvoiceInterest: function (id) {
            var self = this;

            var AccountInterest = self.AccountInterest;
            if(AccountInterest.length > 0){
              var interes = _.filter(AccountInterest,function (item) {
                  return item.invoice_id[0] === id;
              });
              if(interes.length > 0){
                var suma;
                _.each(interes,function(each){
                  suma=0;
                  _.each(each.lines_ids, function(i){
                    var x = _.filter(self.AccountInterestLine,function (item) {
                      return item.id === i;
                    });
                    if(x.length > 0){
                      suma = suma + x[0].amount_interest;
                    }
                  })
                });
                return suma;
              }
              else{
                return 0;
              }
            }
            else{
              return 0;
            }
        },

        /*====================================================================
            GET ACCOUNT MOVE LINE
        ====================================================================*/
        getAccountMoveLine: function (number) {
            var self = this;
            var period = self.$el.find('#current-period').val();
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var AccountMoveLine = _.filter(self.AccountMoveLine,function (item) {
                 return item.move_id[1] == number;
             });
             var x = AccountMoveLine.length;
             var i = AccountMoveLine.length;

            var content =_.map(AccountMoveLine, function(item2){
                if(item2.date_maturity != false){
                    item2.dues_name= 'Cuota ' + i +' / ' + x;
                    i--;
                    return item2;
                };
            });

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        var date = desde.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (item) {
                          return item.date_maturity >= date;
                        }));
                    }
                    if(hasta){
                        var date = hasta.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (item) {
                          return item.date_maturity <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (item) {
                      return item.date_maturity == today;
                    }));
                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (item) {
                      return item.date_maturity == yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (item) {
                      return moment(item.date_maturity,'YYYY-MM-DD').format('YYYY-MM') == currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (item) {
                      return moment(item.date_maturity,'YYYY-MM-DD').format('YYYY-MM') == lastMonth;
                    }));
                }
            }

            if(state && state != 9999999){

              var today = moment().format('YYYY-MM-DD');
                if(state == 'expired'){
                    content = _.flatten(_.filter(content,function (item) {
                        return item.date_maturity <= today && item.amount_residual > 0;
                    }));
                }
                if(state == 'to_receive'){
                    content = _.flatten(_.filter(content,function (item) {
                      return item.amount_residual > 0;
                    }));
                };

                if(state == 'paid'){
                    content = _.flatten(_.filter(content,function (item) {
                      return item.amount_residual == 0;
                    }));
                };
            };

            if(period && period != 9999999){
                var periodo = _.flatten(_.filter(self.AccountPeriod,function (item) {
                    return item.id == period;
                }));

                content = _.flatten(_.filter(content,function (item) {
                    return moment(item.date_maturity,'YYYY-MM-DD').format('MM/YYYY') == periodo[0].name;
                }));
            }
            content = _.filter(content,function(item){
              return item != undefined
            })
            return content;
        },

        /*============================
            ACCOUNT DATA BY MONTH
        ============================*/
        getContent:function(mes) {
            var self = this;
            return _.flatten(_.filter(self.content,function (inv) {
                return moment(inv.date,'YYYY-MM-DD').format('YYYY-MM') === moment(mes).format('YYYY-MM');
            }));
        },

        /*============================
            ACCOUNT DATA BY DAY
        ============================*/
        getContentByDay:function(date) {
            var self = this;
            return _.flatten(_.filter(self.content,function (inv) {
                return moment(inv.date,'YYYY-MM-DD').format('YYYY-MM-DD') === date;
            }));
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var type = $('#current-type').val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }

            var AccountInvoice = self.AccountInvoice;
            _.each(AccountInvoice, function(item){

                var invoice_interest = self.getInvoiceInterest(item.id)

                var AccountMoveLine = self.getAccountMoveLine(item.number);
                var Currency = self.getResCurrency(item.invoice_currency[0]).shift();

                _.each(AccountMoveLine, function(index){

                    var amount = 0;
                    var date;
                    var date_pay;

                    var due_interest = self.getDueInterest(index.id);

                    var state = 'No Pagado';
                    if(index.reconcile_ref){
                        if(index.amount_residual == 0){
                            state = 'Pagado';
                            date_pay = moment(index.date).format('DD/MM/YYYY');
                            console.log(date_pay);
                        }
                        if(index.amount_residual > 0){
                            var value = accounting.formatMoney(index.debit - index.amount_residual, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);
                            state = 'Amortizado ' + ' (' + value + ')';
                        }
                    }

                    date = moment(index.date_maturity,'YYYY-MM-DD').format('DD/MM/YYYY');
                    if(state != 'Pagado'){
                        if(index.date_maturity < moment().format('YYYY-MM-DD')){
                            date = moment(index.date_maturity,'YYYY-MM-DD').format('DD/MM/YYYY') + ' (vencido) ';

                        };
                    };
                    if(index.date_maturity != false || date_pay != false){
                        var days_of_delays =  moment().diff(moment(index.date_maturity), 'days');
                        data.push({
                            invoice_id : item.id,
                            invoice : item.number,
                            supplier_invoice_number : self.valorNull(item.supplier_invoice_number),
                            origin : self.valorNull(item.origin),
                            date_invoice:moment(item.date_invoice).format('DD/MM/YYYY'),
                            partner_ruc : self.valorNull(item.partner_id[2]),
                            partner_name : item.partner_id[1],
                            partner_mobile : self.valorNull(item.partner_info.mobile),
                            partner_phone : self.valorNull(item.partner_info.phone),
                            date : date,
                            date_pay: date_pay,
                            name : index.dues_name,
                            state : state,
                            days_of_delays: days_of_delays > 0 ? days_of_delays : '-',
                            amount : accounting.formatMoney(index.debit, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            due_interest : accounting.formatMoney(due_interest, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            residual : accounting.formatMoney(index.amount_residual + due_interest, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            invoice_residual : accounting.formatMoney(item.residual + invoice_interest, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            invoice_total : accounting.formatMoney(item.amount_total + invoice_interest, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),

                            invoice_residual_no_format : item.residual,
                            amount_no_format : index.debit,
                            residual_no_format : index.amount_residual,

                            decimal_places : CurrencyBase.decimal_places,
                            thousands_separator : CurrencyBase.thousands_separator,
                            decimal_separator : CurrencyBase.decimal_separator,
                        });
                    };
                });
              });

            data.sort(function (a, b) {
              var x = moment(a.date,'DD/MM/YYYY').format('YYYY-MM-DD');
              var y = moment(b.date,'DD/MM/YYYY').format('YYYY-MM-DD');
                if (x > y) {
                    return -1;
                }
                if (x < y) {
                    return 1;
                }
                return 0;
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }

            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var total = totalAmountFormatter(row);
            var residual = totalResidualFormatter(row);

            row.push({
                partner_ruc : 'Totales',
                amount : total,
                residual : residual,
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Análisis de Cuotas.';
                var pdf_type = 'l';
                var pdf_name = 'analisis_de_cuotas_';
                var pdf_columnStyles = {
                    partner_ruc :{columnWidth: 17, halign:'center'},
                    partner_name :{columnWidth: 30, halign:'left'},
                    invoice :{columnWidth: 24, halign:'center'},
                    supplier_invoice_number:{columnWidth: 24, halign:'center'},
                    origin :{columnWidth: 12, halign:'center'},
                    date_invoice : {columnWidth: 21, halign:'center'},
                    name :{columnWidth: 17, halign:'center'},
                    date : {columnWidth: 17, halign:'center'},
                    date_pay : {columnWidth: 17, halign:'center'},
                    state : {columnWidth: 16, halign:'center'},
                    days_of_delays : {columnWidth:13,halign:'center'},
                    amount : {columnWidth: 22, halign:'right'},
                    due_interest:{columnWidth:14,halign:'right'},
                    residual : {columnWidth: 20, halign:'right'},
                    invoice_total : {columnWidth: 21, halign:'right'},
                    invoice_residual : {columnWidth: 20, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter =self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('#current-company').val();
          var store = self.$el.find('#current-store').val();
          var state = self.$el.find('#current-state').val();
          var period = self.$el.find('#current-period').val();
          var journal = self.$el.find('#current-journal').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company != 9999999){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }
          if(state && state != 9999999){
            filter.push({
                title: 'Estado',
                value:  $("#current-state option:selected").text(),
            });
          }

          if(period && period != 9999999){

            var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
                return item.id == period;
            });
            filter.push({
                 title: 'Periodo',
                 value:  AccountPeriod[0].name,
               });
          }

          if(journal && journal != 9999999){
            var AccountJournal =  _.filter(self.AccountJournal,function (item) {
                return item.id == journal;
            });
            filter.push({
                 title: 'Factura',
                 value: AccountJournal[0].name,
               });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        },
    });
}
