function report_profit_and_loss(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportProfitAndLossWidget = reporting.Base.extend({
        template: 'ReportProfitAndLoss',
        rowsData :[],
        content :[],
        modules: ['point_of_sale'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model;
            });
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }

        },

        fetchInitial: function () {
            var self = this;
            self.fetchIntialSQL().then(function (IntialSQL) {
                return IntialSQL;
            }).then(function(IntialSQL) {
                self.ResCompany = IntialSQL.companies;
                if(self.ResCompany .length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany ,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                self.ResStore = IntialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                self.CompanyLogo = IntialSQL.logo;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.AccountInvoice = DataSQL.invoices;
                self.AccountInvoiceLine = DataSQL.invoice_lines;
                self.PosOrder = DataSQL.invoice_lines;
                self.PosOrderLine = DataSQL.order_lines;
                self.ProductCategory = DataSQL.product_categories;
                return self.BuildTable();
            });
        },

        fetchIntialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-profit-loss');
            return data;
        },

        getAccountInvoiceLine: function (id,types) {
            var self = this;
            var content = self.AccountInvoiceLine;
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            content = _.flatten(_.filter(content,function (inv) {
                return _.contains(types, inv.type) && inv.store_id == id;
            }));

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return inv.date >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return inv.date<= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return inv.date === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return inv.date === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') == currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') == lastMonth;
                    }));
                }
            }
            return content;
        },

        getAccountInvoiceExpenseLine: function (id,type) {
            var self = this;
            var content = self.AccountInvoiceLine;
            var store = self.$el.find('#current-store').val();
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            content = _.flatten(_.filter(content,function (inv) {
                return inv.type == type && inv.categ_id == id;
            }));

            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.store_id == store;
                }));
            }

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return inv.date >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return inv.date<= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return inv.date === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return inv.date === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') == currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') == lastMonth;
                    }));
                }
            }
            return content;
        },

        getPosOrderLine: function (id) {
            var self = this;
            var content = self.PosOrderLine;
            var state = self.$el.find('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            content = _.flatten(_.filter(content,function (inv) {
                return inv.store_id == id;
            }));

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') == currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') == lastMonth;
                    }));
                }
            }
            return content;
        },

        getResStore:function () {
            var self = this;
            var content = self.ResStore;
            var store = self.$el.find('#current-store').val();
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.id == store;
                }));
            }
            return content;
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var ResStore = self.getResStore();
            var ProductCategory = self.ProductCategory;
            var CurrencyBase = self.ResCompany[0].currency_id;
            data.push({
                description: 'Ventas',
                decimal_places: CurrencyBase.decimal_places,
                thousands_separator: CurrencyBase.thousands_separator,
                decimal_separator: CurrencyBase.decimal_separator,
            });
            _.each(ResStore,function(item) {
                /*
                #################################
                    ACCOUNT INVOICE LINE
                #################################
                */
                var monto = 0;
                var credit_amount = 0;
                var AccountInvoiceLine = self.getAccountInvoiceLine(item.id,['out_invoice','out_refund']);
                var invoice_amount = _.reduce(_.map(AccountInvoiceLine, function (map) {
                    if(map.type == 'out_refund'){
                        credit_amount += map.price_unit * map.quantity;
                        monto = 0;
                    }else{
                        monto = map.price_unit * map.quantity;
                    }
                    return monto;
                }), function (meno,num) {
                    return meno + num;
                }, 0);

                var coste = 0;
                var credit_cost = 0;
                var invoice_cost = _.reduce(_.map(AccountInvoiceLine, function (map) {
                    if(map.type == 'out_refund'){
                        credit_cost += map.cost;
                        coste = 0;
                    }else{
                        coste = map.cost;
                    }
                    return coste;
                }), function (meno,num) {
                    return meno + num;
                }, 0);
                /*
                #################################
                    POS ORDER LINE
                #################################
                */
                var PosOrderLine = self.getPosOrderLine(item.id);
                var pos_amount = _.reduce(_.map(PosOrderLine, function (map) {
                    return map.price_unit * map.quantity;
                }), function (meno,num) {
                    return meno + num;
                }, 0);
                var pos_cost = _.reduce(_.map(PosOrderLine, function (map) {
                    return map.cost;
                }), function (meno,num) {
                    return meno + num;
                }, 0);
                /*
                #################################
                    TOTAL
                #################################
                */
                var amount = (invoice_amount + pos_amount) - credit_amount;
                var cost = (invoice_cost + pos_cost) - credit_cost;
                data.push({
                    store: item.name,
                    amount_total: accounting.formatMoney(amount, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    amount: amount,
                    cost: cost,
                    type: 'sale',
                });
            });

            var valor = _.reduce(_.map(data, function (map) {
                if(map.amount != undefined){
                    return map.amount;
                }else{
                    return 0;
                }
            }), function (meno,num) {
                return meno + num;
            }, 0);

            var cost = _.reduce(_.map(data, function (map) {
                if(map.amount != undefined){
                    return map.cost;
                }else{
                    return 0;
                }
            }), function (meno,num) {
                return meno + num;
            }, 0);

            data.push({
                store: 'Total de Ventas',
                amount_total: accounting.formatMoney(valor, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                amount: valor,
                type: 'sale',
                check: true,
            });

            data.push({
                description: 'Coste de ventas',
                amount_total: accounting.formatMoney(cost * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                amount: cost * -1,
                expense: true,
            });

            data.push({
                description: 'BENEFICIO BRUTO',
                amount_total: accounting.formatMoney(valor - cost, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                footer_amount: valor - cost,
                amount: valor - cost,
                profit: true,
            });

            data.push({
                description: 'GASTOS',
            });
            var expense = 0;
            _.each(ProductCategory,function(item) {
                var AccountInvoiceExpenseLine = self.getAccountInvoiceExpenseLine(item.id,'in_invoice');
                var amount = _.reduce(_.map(AccountInvoiceExpenseLine, function (map) {
                    if(map.origin == null){
                        return  map.quantity * map.price_unit;
                    }else{
                        var origin = 0;
                        if(map.origin != null){
                            if(map.origin.match(/PO/) == null){

                                origin =  map.quantity * map.price_unit;
                            }
                        }
                        return origin;
                    }
                }), function (meno,num) {
                    return meno + num;
                }, 0);
                amount = amount * -1;
                expense += amount;
                data.push({
                    store: item.name,
                    amount_total: accounting.formatMoney(amount, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    expense_detail: true,
                });
            });
            data.push({
                store: 'Total de Gastos',
                amount_total: accounting.formatMoney(expense, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                footer_amount: expense,
                check: true,
                expense_detail: true,
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        clickOnAction: function (e) {
            var self = this;
            var action = this.$el.find(e.target).val();
            var ResCompany = self.CompanyLogo[0];
            var CurrencyBase = self.ResCompany[0].currency_id;

            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var amount = _.reduce(_.map(row, function (map) {
                if(map.footer_amount != undefined){
                    return map.footer_amount;
                }else{
                    return 0;
                }
            }), function (memo, num) {
                return memo + num;
            });

            amount = accounting.formatMoney(amount, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator);

            if (action === 'pdf') {

                var data = _.map(column, function (val){
                    return val.field;
                });

                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });

                var pdf_title = 'PERDIDAS Y GANANCIAS';
                var pdf_type = '';
                var pdf_name = 'perdidas_y_ganancias_';

                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawProfitAndLossPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    amount
                );
            }
        },
    });
}
