function report_sale_gross(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportSaleGrossWidget = reporting.Base.extend({
        template: 'ReportSaleGross',
        rowsData: [],
        content: [],
        details: [],
        modules: ['point_of_sale'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fecthIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResUser;
            }).then(function (ResUser) {
                self.ResUser = ResUser;
                self.fecthCheckType();
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                if(AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                    _.each(AccountJournal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchAccountInvoice().then(function(AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice) {
                self.AccountInvoice = AccountInvoice;
                return self.fetchAccountInvoiceLine();
            }).then(function (AccountInvoiceLine){
                self.AccountInvoiceLine = AccountInvoiceLine;
                return self.fetchPosOrder();
            }).then(function (PosOrder){
                self.PosOrder = PosOrder;
                return self.fetchPosOrderLine();
            }).then(function (PosOrderLine){
                self.PosOrderLine = PosOrderLine;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fecthIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        /*=====================================================================
            Check type
        =====================================================================*/
        fecthCheckType: function(){
            var self = this;
            var modules = self.checkModel('point_of_sale');
            if(modules.length == 0){
                self.$el.find('.type').css('display','none');
            }
        },

        /*=====================================================================
            USER
        =====================================================================*/
        fetchResUser: function() {
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name','store_id'];
            var domain = [['id','=',self.session.uid]];
            var ResUser = new model.web.Model('res.users');
            ResUser.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*=====================================================================
            ACCOUNT PERIOD
        =====================================================================*/
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var field =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');
            AccountPeriod.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT JOURNAL
        ====================================================================*/
        fetchAccountJournal: function(){
            var self = this;
            var defer = $.Deferred();
            var company = $('#current-company').val();
            var store = $('#current-store').val();
            var domain = [['active','=',true],['type','=','sale']];
            if(company && company != 9999999){
                domain.push(['company_id','=',parseFloat(company)]);
            }
            if(store && store != 9999999){
                domain.push(['store_ids','=',parseFloat(store)]);
            }
            var field = ['id', 'name','store_ids'];
            var AccountJournal = new model.web.Model('account.journal');
            AccountJournal.query(field).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT INVOICE
        ====================================================================*/
        fetchAccountInvoice: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            var period = self.$el.find('#current-period').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var journal = self.$el.find('#current-journal').val();
            if(store && store != 9999999){
                var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                    return item.store_ids == store;
                }), function(map){
                    return map.id;
                });
            }else{
                var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                    return item.id;
                }));
            }
            var domain = [
                ['state', 'in',['open','paid']],
                ['type', '=', 'out_invoice'],
                ['journal_id','in',journal_ids],
            ];
            if(period != 9999999){
                domain.push(['period_id','=',parseInt(period)]);
            }
            if(journal && journal != 9999999){
                domain.push(['journal_id','=',parseInt(journal)]);
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        var date = desde.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date_invoice','>=',date]);
                    }
                    if(hasta){
                        var date = hasta.split('/')
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        domain.push(['date_invoice','<=',date]);
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',today]);
                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',yesterday]);
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['date_invoice','like',currentMonth]);
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['date_invoice','like',lastMonth]);
                }
            }
            var AccountInvoice = new model.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoice',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            ACCOUNT INVOICE LINE
        ====================================================================*/
        fetchAccountInvoiceLine: function (){
            var self = this;
            var invoice_ids = _.flatten(_.map(self.AccountInvoice, function (item) {
                return item.id;
            }));
            var domain = [
                ['invoice_id','in',invoice_ids],
            ];
            var AccountInvoiceLine = new model.web.Model('account.invoice.line');
            return AccountInvoiceLine.call('getAccountInvoiceLine',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            POS ORDER
        ====================================================================*/
        fetchPosOrder: function () {
            var self = this;
            var type = $('#current-type').val();
            var modules = self.checkModel('point_of_sale');
            if (type && modules.length > 0){
                if(type != 'sale'){
                    var store = self.$el.find('#current-store').val();
                    var company = self.$el.find('#current-company').val();
                    var journal = self.$el.find('#current-journal').val();
                    var date = self.$el.find('#current-date').val();
                    var desde = self.$el.find('#from').val();

                    if(store && store != 9999999){
                        var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                            return item.store_ids == store;
                        }), function(map){
                            return map.id;
                        });
                    }else{
                        var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                            return item.id;
                        }));
                    }

                    var domain = [
                        ['state', 'not in',['draft','cancel']],
                        ['sale_journal','in',journal_ids],
                    ];

                    if(company && company != 9999999){
                        domain.push(['company_id','=',parseInt(company)]);
                    }

                    if(journal && journal != 9999999){
                        domain.push(['sale_journal','=',parseInt(journal)]);
                    }

                    if(date && date != 9999999){
                        if(date == 'range'){
                            if(desde){
                                var date = desde.split('/')
                                date = (date[2]+"-"+date[1]+"-"+date[0]);
                                domain.push(['date_order','>=',date]);
                            }
                        }
                    }

                    var PosOrder = new model.web.Model('account.invoice');
                    return PosOrder.call('getPosOrder',[domain], {
                        context: new model.web.CompoundContext()
                    });
                }
            }else{
                var PosOrder = [];
                return PosOrder;
            }
        },
        /*====================================================================
            POS ORDER LINE
        ====================================================================*/
        fetchPosOrderLine: function () {
            var self = this;
            var modules = self.checkModel('point_of_sale');
            if (modules.length > 0){
                var order_ids = _.flatten(_.map(self.PosOrder, function (item) {
                    return item.id;
                }));
                var domain = [
                    ['order_id','in',order_ids],
                ];
                var PosOrderLine = new model.web.Model('account.invoice.line');
                return PosOrderLine.call('getPosOrderLine',[domain], {
                    context: new model.web.CompoundContext()
                });
            }else{
                var PosOrderLine = [];
                return PosOrderLine;
            }
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_ids){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updatePeriodSelections: function () {
            var self = this;
            var period = self.$el.find('#current-period').val();
            if(period != 9999999){
                self.$el.find('#current-date').val(9999999);
                self.$el.find('#current-date').prop('disabled','disabled');
                self.$el.find('.datepicker').css('display','none');
            }else{
                self.$el.find('#current-date').prop('disabled',false);
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        /*====================================================================
            GET ACCOUNT INVOICE LINE
        ====================================================================*/
        getAccountInvoiceLine: function (id, store_id) {
            var self = this;
            return _.filter(self.AccountInvoiceLine,function (item) {
                return item.period_id[0] === id & item.store_id[0] === store_id;
            })
        },

        /*====================================================================
            GET POS ORDER LINE
        ====================================================================*/
        getPosOrderLine: function (date_start,date_stop,store_id) {
            var self = this;
            return _.filter(self.PosOrderLine,function (item) {
                var utc = moment.utc(item.create_date,'YYYY-MM-DD h:mm:ss A');
                utc = moment(utc._d).format('YYYY-MM-DD');
                return utc >= date_start & utc <= date_stop & item.store_id[0] === store_id;
            });
        },

        /*====================================================================
            GET RES STORE
        ====================================================================*/
        getResStore: function () {
            var self = this;
            var content = self.ResStore;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.company_id[0] === parseInt(company);
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.id === parseInt(store);
                }));
            }
            return content;
        },

        /*====================================================================
            GET ACCOUNT PERIOD
        ====================================================================*/
        getAccountPeriod: function () {
            var self = this;
            var content = self.AccountPeriod;
            var company = self.$el.find('#current-company').val();
            var period = self.$el.find('#current-period').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.company_id[0] === parseInt(company);
                }));
            }
            if(period && period != 9999999){
                content = _.flatten(_.filter(content,function (inv) {
                    return inv.id === parseInt(period);
                }));
            }
            return content;
        },

        /*====================================================================
            GET CONTENT BY MONTH
        ====================================================================*/
        getContent:function(id) {
            var self = this;
            return _.flatten(_.filter(self.details,function (inv) {
                return inv.period_id === id;
            }));
        },

        /*============================
            BUILD TABLE
        ============================*/
        BuildTable: function() {
            var self = this;
            var data = [];

            var info = [];
            var details = [];
            var ResStore = self.getResStore();
            var AccountPeriod = self.getAccountPeriod();
            var total_amount_untaxed;
            var total_amount_tax;
            var total_amount_total;
            var total_cost_total;
            var company = $('#current-company').val();
            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            _.each(ResStore, function (item) {
                total_amount_untaxed = 0;
                total_amount_tax = 0;
                total_amount_total = 0;
                total_cost_total = 0;
                info = [];
                _.each(AccountPeriod, function (index) {
                    /*
                    ======================================================================================
                        ACCOUNT INVOICE
                    ======================================================================================
                    */
                    var AccountInvoiceLine = self.getAccountInvoiceLine(index.id, item.id);
                    var invoice_amount_untaxed = 0;
                    var invoice_amount_tax = 0;
                    var invoice_amount_cost = 0;
                    var invoice_amount_total = 0;
                    if(AccountInvoiceLine.length > 0){
                        /*
                        ================
                            SUB-TOTAL
                        ================
                        */
                        invoice_amount_untaxed = _.reduce(_.map(AccountInvoiceLine,function(item) {
                            return item.price_subtotal_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            IMPUESTOS
                        ================
                        */
                        invoice_amount_tax = _.reduce(_.map(AccountInvoiceLine,function(item) {
                            return item.tax_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            COSTE
                        ================
                        */
                        invoice_amount_cost = _.reduce(_.map(AccountInvoiceLine,function(item) {
                            return item.product_id[3] * item.quantity;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            TOTAL
                        ================
                        */
                        invoice_amount_total = _.reduce(_.map(AccountInvoiceLine,function(item) {
                            return item.amount_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                    };
                    /*
                    ======================================================================================
                        POS ORDER LINE
                    ======================================================================================
                    */
                    var PosOrderLine = self.getPosOrderLine(index.date_start, index.date_stop, item.id);
                    var pos_amount_untaxed = 0;
                    var pos_amount_tax = 0;
                    var pos_amount_cost = 0;
                    var pos_amount_total = 0;
                    if(PosOrderLine.length > 0){
                        /*
                        ================
                            SUB-TOTAL
                        ================
                        */
                        pos_amount_untaxed = _.reduce(_.map(PosOrderLine,function(item) {
                            return item.price_subtotal_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            IMPUESTOS
                        ================
                        */
                        pos_amount_tax = _.reduce(_.map(PosOrderLine,function(item) {
                            return item.price_subtotal_incl_currency - item.price_subtotal_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            COSTE
                        ================
                        */
                        pos_amount_cost = _.reduce(_.map(PosOrderLine,function(item) {
                            return item.product_id[2];
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                        /*
                        ================
                            TOTAL
                        ================
                        */
                        pos_amount_total = _.reduce(_.map(PosOrderLine,function(item) {
                            return item.price_subtotal_incl_currency;
                        }),function(memo, num) {
                            return memo + num;
                        },0);
                    };
                    if(AccountInvoiceLine.length > 0 || PosOrderLine.length > 0){
                        var margin = ((invoice_amount_cost + pos_amount_cost) * 100)/(invoice_amount_untaxed + pos_amount_untaxed);
                        margin = 100 - margin;
                        info.push({
                            period : index.name,
                            subtotal : accounting.formatMoney((invoice_amount_untaxed + pos_amount_untaxed), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            tax : accounting.formatMoney((invoice_amount_tax + pos_amount_tax), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            cost : accounting.formatMoney((invoice_amount_cost + pos_amount_cost), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            margin : accounting.formatNumber(margin,2,".",",") + '%',
                            total : accounting.formatMoney((invoice_amount_total + pos_amount_total), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            profit : accounting.formatMoney(((invoice_amount_untaxed + pos_amount_untaxed) - (invoice_amount_cost + pos_amount_cost)), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                            /*=======================
                                VALORES SIN FORMATEAR
                            =======================*/
                            subtotal_amount : invoice_amount_untaxed + pos_amount_untaxed,
                            tax_amount : invoice_amount_tax + pos_amount_tax,
                            cost_amount : invoice_amount_cost + pos_amount_cost,
                            total_amount : invoice_amount_total + pos_amount_total,
                            profit_amount : (invoice_amount_untaxed + pos_amount_untaxed) - (invoice_amount_cost + pos_amount_cost),
                        });
                        details.push({
                            period : index.name,
                            period_id : index.id,
                            subtotal_amount : invoice_amount_untaxed + pos_amount_untaxed,
                            tax_amount : invoice_amount_tax + pos_amount_tax,
                            cost_amount : invoice_amount_cost + pos_amount_cost,
                            total_amount : invoice_amount_total + pos_amount_total,
                            profit_amount : (invoice_amount_untaxed + pos_amount_untaxed) - (invoice_amount_cost + pos_amount_cost),
                        });
                    };
                    /*
                    ======================================================================================
                        TOTALES
                    ======================================================================================
                    */
                    total_amount_untaxed = total_amount_untaxed + invoice_amount_untaxed + pos_amount_untaxed;
                    total_amount_tax = total_amount_tax + invoice_amount_tax + pos_amount_tax;
                    total_cost_total = total_cost_total + invoice_amount_cost + pos_amount_cost;
                    total_amount_total = total_amount_total + invoice_amount_total + pos_amount_total;

                });

                var margin = ((total_amount_untaxed - total_cost_total) / total_amount_untaxed) * 100;
                // margin = 100 - margin;

                data.push({
                    id : item.id,
                    name : item.name,
                    subtotal_amount : accounting.formatMoney(total_amount_untaxed, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    tax_amount : accounting.formatMoney(total_amount_tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    cost_amount : accounting.formatMoney(total_cost_total, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    margin : accounting.formatNumber(margin,2,".",",") + '%',
                    total_amount : accounting.formatMoney(total_amount_total, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    profit_amount : accounting.formatMoney((total_amount_untaxed - total_cost_total), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*=======================
                        VALORES SIN FORMATEAR
                    =======================*/
                    subtotal : total_amount_untaxed,
                    tax : total_amount_tax,
                    cost : total_cost_total,
                    total : total_amount_total,
                    profit : total_amount_untaxed - total_cost_total,
                    /*==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================*/
                    decimal_places : CurrencyBase.decimal_places,
                    thousands_separator: CurrencyBase.thousands_separator,
                    decimal_separator: CurrencyBase.decimal_separator,
                    /*==============================
                        DATA
                    ==============================*/
                    info : info,
                });
            });
            self.details = details;
            self.content = data;
            self.loadTable(data);
            self.CallCharts(data,CurrencyBase);
        },

        /*
        ======================================================================
            LLAMAR LOS GRAFICOS
        ======================================================================
        */
        CallCharts: function(data,CurrencyBase){
            var self = this;
            /*
            ================================================
            MULTIPLES GRAFICOS
            ================================================
            */
            var MultipleChart = new reporting.ReportChartWidget(self);
            var item;
            var label = [];
            var AccountPeriod = self.AccountPeriod
            var body_subtotal = [];
            var body_tax = [];
            var body_cost = [];
            var body_total = [];
            var body_profit = [];
            _.each(AccountPeriod, function (item) {
                var content = self.getContent(item.id);
                if(content.length > 0){
                    /*
                    =============================
                        SUBTOTAL
                    =============================
                    */
                    var subtotal = _.reduce(_.map(content,function(item) {
                        return item.subtotal_amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                    /*
                    =============================
                        IMPUESTOS
                    =============================
                    */
                    var tax = _.reduce(_.map(content,function(item) {
                        return item.tax_amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                    /*
                    =============================
                        COSTE
                    =============================
                    */
                    var cost = _.reduce(_.map(content,function(item) {
                        return item.cost_amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                    /*
                    =============================
                        COSTE
                    =============================
                    */
                    var total = _.reduce(_.map(content,function(item) {
                        return item.total_amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);
                    /*
                    =============================
                        BENEFICIO
                    =============================
                    */
                    var profit = _.reduce(_.map(content,function(item) {
                        return item.profit_amount;
                    }),function(memo, num) {
                        return memo + num;
                    },0);

                    body_subtotal.push(subtotal);
                    body_tax.push(tax);
                    body_cost.push(cost);
                    body_total.push(total);
                    body_profit.push(profit);
                    label.push(item.name);

                }
            });
            MultipleChart.BuildMultipleChart(CurrencyBase,label,body_subtotal,body_tax,body_cost,body_total,body_profit);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },

    });
}
