function report_sale_utility_analytic(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportSaleUtilityAnalyticWidget = reporting.Base.extend({
        template: 'ReportSaleUtilityAnalytic',
        rowsData :[],
        content :[],
        modules: ['product_brand','point_of_sale'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-company' : 'updateSelections',
            'change #current-attribute' : 'updateAttributeSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-period' : 'updatePeriodSelections',
            'change #current-date' : 'ShowDateRange',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
        },

        clickAnalysisDetail: function(e, row, $element,field){
            if (field == 'product_name'){
                this.do_action({
                    name:"Producto",
                    type: 'ir.actions.act_window',
                    res_model: "product.product",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.product_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.product_id,
                });
            }
            e.stopImmediatePropagation();
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModule : function(module){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === module;
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIntialSQL().then(function (IntialSQL) {
                return IntialSQL;
            }).then(function(IntialSQL) {
                /*
                =================================
                    RES COMPANY
                =================================
                */
                self.ResCompany = IntialSQL.companies;
                self.CompanyLogo = IntialSQL.logo;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                /*
                =================================
                    RES STORE
                =================================
                */
                self.ResStore = IntialSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                /*
                =================================
                    ACCOUNT JOURNAL
                =================================
                */
                self.AccountJournal = IntialSQL.journals;
                if(self.AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                    _.each(self.AccountJournal,function(item){
                        if(item.type == 'sale'){
                            self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                        }
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                /*
                =================================
                    PRODUCT CATEGORY
                =================================
                */
                self.ProductCategory = IntialSQL.categories;
                if(self.ProductCategory.length > 1){
                    self.$el.find('#current-category').append('<option value="9999999">Todos las Categorias</option>');
                    _.each(self.ProductCategory,function(item){
                        self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }
                self.ProductBrand = IntialSQL.brands;
                if(self.ProductBrand.length > 1){
                    self.$el.find('#current-brand').append('<option value="9999999">Todas las Marcas</option>');
                    _.each(self.ProductBrand,function(item){
                        self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.brand').css('display','none');
                }
                self.ProductAttribute = IntialSQL.attributes;
                if(self.ProductAttribute.length > 1){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todas los atributos</option>');
                    _.each(self.ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                self.ProductAttributeValue = IntialSQL.attribute_values;
                if(self.ProductAttributeValue.length > 1){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todas los valores de atributos</option>');
                    _.each(self.ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
                return self.fetchIrModuleModule();
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchCheckType();
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchDataSQL().then(function(DataSQL) {
                return DataSQL;
            }).then(function (DataSQL) {
                self.AccountInvoiceLine = DataSQL.invoice_lines;
                self.PosOrderLine = DataSQL.order_lines;
                return self.BuildTable();
            });
        },

        fetchIntialSQL: function() {
            var self = this;
            var data = $.get('/report-filter-data');
            return data;
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-sale-utility-analytic');
            return data;
        },

        fetchIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        fetchCheckType: function(){
            var self = this;
            var modules = self.checkModule('point_of_sale');
            if(modules.length == 0){
                self.$el.find('.type').css('display','none');
            }
        },

        updateSelections: function () {
            var self = this;
            var store;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateAttributeSelections: function () {
            var self = this;
            var attribute_value;
            var attribute = self.$el.find('#current-attribute').val();
            if(attribute != 9999999){
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    if(parseFloat(attribute) == item.attribute_id){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var journal;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_id){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getProductCategory: function (id) {
            var self = this;
            var category;
            category =  _.filter(self.ProductCategory,function (item) {
                return item.id == id;
            });
            if(category.length > 0)
                return category[0].name;
        },

        getPosOrderLine:function() {
            var self = this;
            var content = self.PosOrderLine;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var journal = self.$el.find('#current-journal').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }
            if(type && type != 9999999){
                if(type == 'sale'){
                    content = [];
                }
            }
            if(journal && journal != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.journal_id == journal;
                }));
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                            utc = moment(utc._d).format('YYYY-MM-DD');
                            return moment(utc).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        var utc = moment.utc(inv.date,'YYYY-MM-DD h:mm:ss A');
                        utc = moment(utc._d).format('YYYY-MM-DD');
                        return moment(utc).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            if(category && category != 9999999){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                content = _.flatten(_.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.categ_id);
                }));
            }
            if(brand && brand != 9999999){
                content = _.filter(content,function (item) {
                    return item.product_brand_id == parseInt(brand);
                });
            }
            if(attribute && attribute != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_ids, parseInt(attribute));
                });
            }
            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_value_ids, parseInt(attribute_value));
                });
            }
            return content;
        },

        getAccountInvoiceLine:function(invoice_type) {
            var self = this;
            var content = self.AccountInvoiceLine;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var type = self.$el.find('#current-type').val();
            var journal = self.$el.find('#current-journal').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            content = _.flatten(_.filter(content,function (item) {
                return item.type == invoice_type;
            }));
            if(company && company != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.company_id == company;
                }));
            }
            if(store && store != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.store_id == store;
                }));
            }
            if(type && type != 9999999){
                if(type == 'tpv'){
                    content = [];
                }
            }
            if(journal && journal != 9999999){
                content = _.flatten(_.filter(content,function (item) {
                    return item.journal_id == journal;
                }));
            }
            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') >= date;
                        }));
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.flatten(_.filter(content,function (inv) {
                            return moment(inv.date).format('YYYY-MM-DD') <= date;
                        }));
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === today;
                    }));
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM-DD') === yesterday;
                    }));
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === currentMonth;
                    }));
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.flatten(_.filter(content,function (inv) {
                        return moment(inv.date).format('YYYY-MM') === lastMonth;
                    }));
                }
            }
            if(category && category != 9999999){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id) || item.id == category;
                }), function(map){
                    return map.id;
                });
                content = _.flatten(_.filter(content,function (inv) {
                    return _.contains(categ_ids, inv.categ_id);
                }));
            }
            if(brand && brand != 9999999){
                content = _.filter(content,function (item) {
                    return item.product_brand_id == parseInt(brand);
                });
            }
            if(attribute && attribute != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_ids, parseInt(attribute));
                });
            }
            if(attribute_value && attribute_value != 9999999){
                content = _.filter(content,function (item) {
                    return _.contains(item.attribute_value_ids, parseInt(attribute_value));
                });
            }
            return content;
        },

        BuildTable: function(){
            var self = this;

            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;
            var PosOrderLine = self.getPosOrderLine();
            var display_name;
            var modules = self.checkModule('product_brand');
            var margin;
            _.each(PosOrderLine,function(item) {
                var category = self.getProductCategory(item.categ_id);
                if(item.attribute_values[0] == null){
                    display_name = item.product_name;
                }else{
                    display_name = item.product_name + ' (' + _.uniq(item.attribute_values) + ')';
                }
                if(modules.length > 0){
                    if(item.product_brand_id != null){
                        display_name = display_name + ' ( ' + item.brand_name + ')';
                    }
                }
                margin = (((item.subtotal) - (item.cost * item.quantity)) / (item.subtotal)) * 100;
                data.push({
                    /*
                    =============================
                        IDS
                    =============================
                    */
                    id:item.order_line_id,
                    product_id:item.product_id,
                    /*
                    =============================
                        INFO
                    =============================
                    */
                    number:item.name,
                    date_invoice:moment(item.date).format('DD/MM/YYYY'),
                    product_name:display_name,
                    cost:accounting.formatMoney(item.cost, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    price_unit:accounting.formatMoney(item.price_unit, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    quantity:accounting.formatNumber(item.quantity,2,'.',','),
                    cost_total:accounting.formatMoney(item.cost * item.quantity, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    subtotal:accounting.formatMoney(item.subtotal, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    tax:accounting.formatMoney(item.tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    total:accounting.formatMoney(item.subtotal + item.tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    margin:accounting.formatNumber(margin,2,'.',',') + '%',
                    profit:accounting.formatMoney((item.subtotal) - (item.cost * item.quantity), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*
                    =============================
                        VALORES SIN FORMATEAR
                    =============================
                    */
                    date:item.date,
                    cost_value:item.cost,
                    price_unit_value:item.price_unit,
                    quantity_value:item.quantity,
                    cost_total_value:item.cost * item.quantity,
                    subtotal_value:item.subtotal,
                    tax_value:item.tax,
                    total_value:item.subtotal + item.tax,
                    profit_value:(item.subtotal) - (item.cost * item.quantity),
                    /*
                    ==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================
                    */
                    decimal_places:CurrencyBase.decimal_places,
                    thousands_separator:CurrencyBase.thousands_separator,
                    decimal_separator:CurrencyBase.decimal_separator,
                });
            });
            var AccountInvoiceLine = self.getAccountInvoiceLine('out_invoice');
            _.each(AccountInvoiceLine,function(item) {
                var category = self.getProductCategory(item.categ_id);
                if(item.attribute_values[0] == null){
                    display_name = item.product_name;
                }else{
                    display_name = item.product_name + ' (' + _.uniq(item.attribute_values) + ')';
                }
                if(modules.length > 0){
                    if(item.product_brand_id != null){
                        display_name = display_name + ' ( ' + item.brand_name + ')';
                    }
                }
                margin = (((item.subtotal) - (item.cost * item.quantity)) / (item.subtotal)) * 100;
                data.push({
                    /*
                    =============================
                        IDS
                    =============================
                    */
                    id:item.account_invoice_line_id,
                    product_id:item.product_id,
                    /*
                    =============================
                        INFO
                    =============================
                    */
                    number:item.number,
                    date_invoice:moment(item.date).format('DD/MM/YYYY'),
                    product_name:display_name,
                    cost:accounting.formatMoney(item.cost, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    price_unit:accounting.formatMoney(item.price_unit, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    quantity:accounting.formatNumber(item.quantity,2,'.',','),
                    cost_total:accounting.formatMoney(item.cost * item.quantity, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    subtotal:accounting.formatMoney(item.subtotal, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    tax:accounting.formatMoney(item.tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    total:accounting.formatMoney(item.subtotal + item.tax, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    margin:accounting.formatNumber(margin,2,'.',',') + '%',
                    profit:accounting.formatMoney((item.subtotal) - (item.cost * item.quantity), '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*
                    =============================
                        VALORES SIN FORMATEAR
                    =============================
                    */
                    date:item.date,
                    cost_value:item.cost,
                    price_unit_value:item.price_unit,
                    quantity_value:item.quantity,
                    cost_total_value:item.cost * item.quantity,
                    subtotal_value:item.subtotal,
                    tax_value:item.tax,
                    total_value:item.subtotal + item.tax,
                    profit_value: (item.subtotal) - (item.cost * item.quantity),
                    /*
                    ==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================
                    */
                    decimal_places:CurrencyBase.decimal_places,
                    thousands_separator:CurrencyBase.thousands_separator,
                    decimal_separator:CurrencyBase.decimal_separator,
                });
            });
            var AccountInvoiceLineRefund = self.getAccountInvoiceLine('out_refund');
            _.each(AccountInvoiceLineRefund,function(item) {
                var category = self.getProductCategory(item.categ_id);
                if(item.attribute_values[0] == null){
                    display_name = item.product_name;
                }else{
                    display_name = item.product_name + ' (' + _.uniq(item.attribute_values) + ')';
                }
                if(modules.length > 0){
                    if(item.product_brand_id != null){
                        display_name = display_name + ' ( ' + item.brand_name + ')';
                    }
                }
                margin = 0 + '%';
                data.push({
                    /*
                    =============================
                        IDS
                    =============================
                    */
                    id:item.account_invoice_line_id,
                    product_id:item.product_id,
                    /*
                    =============================
                        INFO
                    =============================
                    */
                    number:item.number,
                    date_invoice:moment(item.date).format('DD/MM/YYYY'),
                    product_name:display_name,
                    cost:accounting.formatMoney(item.cost * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    price_unit:accounting.formatMoney(item.price_unit * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    quantity:accounting.formatNumber(item.quantity * -1,2,'.',','),
                    cost_total:accounting.formatMoney((item.cost * item.quantity) * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    subtotal:accounting.formatMoney(item.subtotal * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    tax:accounting.formatMoney(item.tax * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    total:accounting.formatMoney((item.subtotal + item.tax) * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    margin:accounting.formatNumber(margin,2,'.',',') + '%',
                    profit:accounting.formatMoney((item.subtotal - (item.cost * item.quantity)) * -1, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*
                    =============================
                        VALORES SIN FORMATEAR
                    =============================
                    */
                    date:item.date,
                    cost_value:item.cost*-1,
                    price_unit_value:item.price_unit*-1,
                    quantity_value:item.quantity*-1,
                    cost_total_value:(item.cost * item.quantity)*-1,
                    subtotal_value:item.subtotal*-1,
                    tax_value:item.tax*-1,
                    total_value:(item.subtotal + item.tax)*-1,
                    profit_value:(item.subtotal - (item.cost * item.quantity))*-1,
                    /*
                    ==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================
                    */
                    decimal_places:CurrencyBase.decimal_places,
                    thousands_separator:CurrencyBase.thousands_separator,
                    decimal_separator:CurrencyBase.decimal_separator,
                });
            });
            data.sort(function (a, b) {
                if (a.date > b.date) {
                    return -1;
                }
                if (a.date < b.date) {
                    return 1;
                }
                return 0;
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var CurrencyBase;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = _.flatten(_.filter(self.CompanyLogo,function (inv) {
                    return inv.id == company;
                }));
                ResCompany = ResCompany[0];
                CurrencyBase = ResCompany[0].currency_id;
            }else{
                ResCompany = self.CompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }
            var getColumns = [];
            var rows = [];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var quantity = QuantityFooter(row);
            var cost_total = CostTotalFooter(row);
            var subtotal = SubtotalFooter(row);
            var tax = TaxFooter(row);
            var total = TotalFooter(row);
            var profit = ProfitFooter(row);

            row.push({
                number:'Totales',
                quantity:quantity,
                cost_total:cost_total,
                subtotal:subtotal,
                tax:tax,
                total:total,
                profit:profit,
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Análisis de Utilidad.';
                var pdf_type = 'l';
                var pdf_name = 'analisis_de_utilidad_de_ventas';
                var pdf_columnStyles = {
                    number:{columnWidth: 25, halign:'center'},
                    date_invoice:{columnWidth: 18, halign:'center'},
                    product_name:{columnWidth: 'auto', halign:'left'},
                    cost:{columnWidth: 20, halign:'right'},
                    price_unit:{columnWidth: 20, halign:'right'},
                    quantity:{columnWidth: 20, halign:'right'},
                    cost_total:{columnWidth: 20, halign:'right'},
                    subtotal:{columnWidth: 20, halign:'right'},
                    tax:{columnWidth: 20, halign:'right'},
                    total:{columnWidth: 20, halign:'right'},
                    margin:{columnWidth: 20, halign:'right'},
                    profit:{columnWidth: 20, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
               );
            }
        },
        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var journal = self.$el.find('#current-journal').val();
            var type = self.$el.find('#current-type').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var filter = [];
            if(company && company != 9999999){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                    return item.id == store;
                });
                filter.push({
                    title: 'Sucursal',
                    value:  ResStore[0].name,
                });
            }
            if(journal && journal != 9999999){
                var AccountJournal = _.filter(self.AccountJournal, function(item){
                    return item.id == journal;
                });
                filter.push({
                    title:'Factura',
                    value: AccountJournal[0].name,
                });
            }
            if(type && type != 9999999){
                filter.push({
                    title: 'Tipo de Venta',
                    value:  $("#current-type option:selected").text(),
                });
            }
            if(category && category != 9999999){
                var categ =  _.filter(self.ProductCategory,function (item) {
                    return item.id == category;
                });
                filter.push({
                    title: 'Categoría',
                    value: categ[0].name,
                });
            }
            if(brand && brand != 9999999){
                var content =  _.filter(self.ProductBrand,function (item) {
                    return item.id == brand;
                });
                filter.push({
                    title: 'Marca',
                    value: brand[0].name,
                });
            }
            if(attribute && attribute != 9999999){
                var attr =  _.filter(self.ProductAttribute,function (item) {
                    return item.id == attribute;
                });
                filter.push({
                    title: 'Atributo',
                    value: attr[0].name,
                });
            }
            if(attribute_value && attribute_value != 9999999){
                var attr_value =  _.filter(self.ProductAttributeValue,function (item) {
                    return item.id == attribute_value;
                });
                filter.push({
                    title: 'Valor de Atributo',
                    value: attr_value[0].name,
                });
            }

            if(date && date != 9999999){
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });
                if(date == 'range'){
                    filter.push({
                        title: 'Fecha',
                        value:  desde +' al '+hasta,
                    });
                }else{
                    var fecha;
                    if(date == 'today'){
                        fecha = moment().format('DD/MM/YYYY');
                    }
                    if(date == 'yesterday'){
                        fecha = moment().add(-1,'days').format('DD/MM/YYYY');
                    }
                    if(date == 'currentMonth'){
                        fecha = moment().format('MMMM/YYYY');
                    }
                    if(date == 'lastMonth'){
                        fecha = moment().add(-1,'months').format('MMMM/YYYY');
                    }
                    filter.push({
                        title:'Fecha',
                        value:fecha,
                    });
                }
            }
            return filter;
        }
    });
}
