﻿function report_stock_history(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportStockHistoryWidget = reporting.Base.extend({
        template: 'ReportStockHistory',
        rowsData :[],
        content :[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-store' : 'updateTypeSelections',
            'change #current-date' : 'ShowDateRange',
            'change #current-company': 'updateSelections',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                  self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                  _.each(ResCompany,function(item){
                    self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                  });
                }else{
                  self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 0){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchStockPickingType();
            }).then(function(StockPickingType){
                self.StockPickingType = StockPickingType;
                if(StockPickingType.length > 0){
                    self.$el.find('#current-type').append('<option value="9999999">Todas las operaciones</option>');
                    _.each(StockPickingType,function(item){
                        self.$el.find('#current-type').append('<option value="' + item.id + '">' + item.warehouse_id[1] +' '+item.name + '</option>');
                    });
                }else{
                    self.$el.find('.type').css('display','none');
                }
                return self.fetchStockLocation();
            }).then(function(StockLocation){
                self.StockLocation = StockLocation;
                if(StockLocation.length > 1){
                    self.$el.find('#current-location').append('<option value="9999999">Todas las ubicaciones</option>');
                    _.each(StockLocation,function(item){
                        self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                    });

                    self.$el.find('#current-location2').append('<option value="9999999">Todas las ubicaciones</option>');
                    _.each(StockLocation,function(item){
                        self.$el.find('#current-location2').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                    });
                }else{
                    self.$el.find('.location').css('display','none');
                }
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            self.fetchStockPicking().then(function(StockPicking) {
                return StockPicking;
            }).then(function (StockPicking) {
                self.StockPicking = StockPicking;
                return self.fetchStockMove();
            }).then(function (StockMove){
                self.StockMove = StockMove;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fetchIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed']];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            STOCK PICKING TYPE
        ====================================================================*/
        fetchStockPickingType:function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('stock.picking.type');
            var field=['id','name','code','warehouse_id','store_id'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        /*====================================================================
            STOCK LOCATION
        ====================================================================*/
        fetchStockLocation: function () {
            var self = this;
            var domain = [
                ['active', '=',true],
            ];
            var StockLocation = new model.web.Model('stock.location');
            return StockLocation.call('getStockLocation',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
          STOCK MOVE
        ====================================================================*/
        fetchStockMove: function () {
            var self = this;

            var picking_ids = _.flatten(_.map(self.StockPicking, function (item) {
                return item.id;
            }));
            var domain = [
                ['state','=','done'],
                ['picking_id','in',picking_ids],
            ];

            var StockMove = new model.web.Model('stock.move');
            return StockMove.call('getStockMove',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            STOCK PICKING
        ====================================================================*/
        fetchStockPicking: function () {
            var self = this;
            var categ_ids = [];
            var company = $('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var type = self.$el.find('#current-type').val();
            var type_code = self.$el.find('#current-type-code').val();

            var domain = [
                ['state','=','done'],
            ];

            if(company && company != 9999999){
                domain.push(['company_id','=',parseFloat(company)]);
            }

            if(type && type != 9999999){
              domain.push(['picking_type_id','=',  parseInt(type)]);
            }

            if(type_code && type_code != 9999999){
              domain.push(['picking_type_id.code','=', type_code]);
            }

            if(store && store != 9999999){
              domain.push(['store_id', '=', parseInt(store)]);
            }

            if(date && date != 9999999){

                if(desde){
                    var date = desde.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['create_date','>=',date]);
                }

                if(hasta){
                    var date = hasta.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['create_date','<=',date]);
                }

                if(date == 'today'){
                  var today = moment().format('YYYY-MM-DD ');
                  domain.push(['create_date','like',today]);

                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD ');
                    domain.push(['create_date','like',yesterday]);
                }

                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['create_date','like',currentMonth]);
                }

                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['create_date','like',lastMonth]);
                }
            }

            var StockPicking = new model.web.Model('stock.picking');
            return StockPicking.call('getStockPicking',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateTypeSelections: function () {
          var self = this;
          var store = self.$el.find('#current-store').val();
          var type = self.$el.find('#current-type').empty();
          self.$el.find('#current-type').append('<option value="9999999">Todas las operaciones</option>');
          if(store != 9999999){
            _.each(self.StockPickingType,function(item){
              if(parseFloat(store) == item.store_id[0]){
                self.$el.find('#current-type').append('<option value="' + item.id + '">' + item.warehouse_id[1] +' '+item.name + '</option>');
              }
            });
          }else{
            _.each(self.StockPickingType,function(item){
              self.$el.find('#current-type').append('<option value="' + item.id + '">' + item.warehouse_id[1] +' '+item.name + '</option>');
            });
          }
        },

        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        /*====================================================================
          GET STOCK MOVE
        ====================================================================*/
        getStockMove: function (id) {
            var self = this;
            return _.filter(self.StockMove,function (item) {
                return item.picking_id.id == id;
            })
        },

        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },


        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var StockPicking = self.StockPicking;
            _.each(StockPicking, function(item){
                var info = [];
                var sum_item = 0;
                var StockMove = self.getStockMove(item.id);
                _.each(StockMove, function(item_move){
                  sum_item = sum_item +  item_move.product_uom_qty;
                  info.push({
                      id : item_move.id,

                      origin : self.valorNull(item_move.origin),
                      product_id : item_move.product_id.display_name,
                      location_id : item_move.location_id.complete_name,
                      qty : item_move.product_uom_qty,
                      location_dest_id : item_move.location_dest_id.complete_name,
                });

              });

              data.push({
                id: item.id,
                name : item.name,
                partner_name : self.valorNull(item.partner_id.name),
                date : moment(item.date).format('DD/MM/YYYY'),
                picking_type_name : item.picking_type_id.name,
                sum_item : accounting.formatNumber(sum_item,'','.',','),

                sum_item_no_format: sum_item,

                info: info,

              });
            });

            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var action = this.$el.find(e.target).val();
            var company = self.$el.find('#current-company').val();
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            var ResCompany = self.ResCompany[0];

            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
            }

            var total = totalFormatter(row);

            row.push({
              name: 'Totales',
              sum_item: total,
            })

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });

                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Historial de Inventario.';
                var pdf_type = '';
                var pdf_name = 'historial_de_inventario_';
                var pdf_columnStyles = {
                  name : {columnWidth: 30, halign:'left'},
                  partner_name : {columnWidth: 65, halign:'left'},
                  date : {columnWidth: 20, halign:'center'},
                  picking_type_name : {columnWidth: 50, halign:'left'},
                  sum_item : {columnWidth: 30, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter,
                );
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('current-company').val();
          var store = self.$el.find('#current-store').val();
          var type = self.$el.find('#current-type').val();
          var type_code = self.$el.find('#current-type-code').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company != 9999999){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }

          if(type && type != 9999999){
            var StockPickingType = _.filter(self.StockPickingType, function(item){
              return item.id == type;
            });
            filter.push({
              title: 'Nombre de Operación',
              value: StockPickingType[0].name,
            })
          }

          if(type_code && type_code != 9999999){
            filter.push({
                title: 'Tipo de Operación',
                value:  $("#current-type-code option:selected").text(),
            });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        }
    });
}
