function report_stock_movement(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportStockMovementWidget = reporting.Base.extend({
        template: 'ReportStockMovement',
        rowsData :[],
        content :[],
        modules: ['product_brand'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-attribute' : 'updateAttributeSelections',
            'change #current-date' : 'ShowDateRange',
            'change #current-company':'updateSelections',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new reporting.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        checkModel : function(model){
            var self = this;
            return _.filter(self.IrModuleModule,function(item){
                return item.name === model
            });
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        fetchInitial: function () {
            var self = this;
            self.fetchIrModuleModule().then(function (IrModuleModule) {
                return IrModuleModule;
            }).then(function(IrModuleModule) {
                self.IrModuleModule = IrModuleModule;
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                  self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                  _.each(ResCompany,function(item){
                    self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                  });
                }else{
                  self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 0){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchStockLocation();
            }).then(function(StockLocation){
                self.StockLocation = StockLocation;
                if(StockLocation.length > 1){
                    self.$el.find('#current-location').append('<option value="9999999">Todas las ubicaciones</option>');
                    _.each(StockLocation,function(item){
                        self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                    });

                    self.$el.find('#current-location2').append('<option value="9999999">Todas las ubicaciones</option>');
                    _.each(StockLocation,function(item){
                        self.$el.find('#current-location2').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                    });
                }else{
                    self.$el.find('.location').css('display','none');
                }
                return self.fetchProductBrand();
            }).then(function(ProductBrand){
                self.ProductBrand = ProductBrand;
                if(ProductBrand.length > 1){
                    self.$el.find('#current-brand').append('<option value="9999999">Todas las marcas</option>');
                    _.each(ProductBrand,function(item){
                        self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.brand').css('display','none');
                }
                return self.fetchProductCategory();
            }).then(function(ProductCategory){
                self.ProductCategory = ProductCategory;
                if(ProductCategory.length > 1){
                    self.$el.find('#current-category').append('<option value="9999999">Todas las categorias</option>');
                    _.each(ProductCategory,function(item){
                        self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                    });
                }else{
                    self.$el.find('.category').css('display','none');
                }
                return self.fetchProductAttribute();
            }).then(function(ProductAttribute){
                self.ProductAttribute = ProductAttribute;
                if(ProductAttribute.length > 0){
                    self.$el.find('#current-attribute').append('<option value="9999999">Todos los atributos</option>');
                    _.each(ProductAttribute,function(item){
                        self.$el.find('#current-attribute').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute').css('display','none');
                }
                return self.fetchProductAttributeValue();
            }).then(function(ProductAttributeValue){
                self.ProductAttributeValue = ProductAttributeValue;
                if(ProductAttributeValue.length > 1){
                    self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                    _.each(ProductAttributeValue,function(item){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.attribute-value').css('display','none');
                }
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.fetchStockMove().then(function(StockMove) {
                return StockMove;
            }).then(function (StockMove) {
                self.StockMove = StockMove;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            IR MODULE
        =====================================================================*/
        fetchIrModuleModule: function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['name','id'];
            var domain=[['state','=','installed'],['name','in',self.modules]];
            var IrModuleModule = new model.web.Model('ir.module.module');
            IrModuleModule.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            STOCK LOCATION
        ====================================================================*/
        fetchStockLocation: function () {
            var self = this;
            var domain = [
                ['active', '=',true],
            ];
            var StockLocation = new model.web.Model('stock.location');
            return StockLocation.call('getStockLocation',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            PRODUCT BRAND
        ====================================================================*/
        fetchProductBrand: function () {
            var self = this;
            var domain = [];
            var modules = self.checkModel('product_brand');
            if (modules.length > 0){
                var ProductBrand = new model.web.Model('product.product');
                return ProductBrand.call('getProductBrand',[domain], {
                    context: new model.web.CompoundContext()
                });
            }else{
                var ProductBrand = [];
                return ProductBrand;
            }
        },

        /*====================================================================
            PRODUCT CATEGORY
        ====================================================================*/
        fetchProductCategory: function () {
            var self = this;
            var domain = [];
            var ProductCategory = new model.web.Model('product.category');
            return ProductCategory.call('getProductCategory',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            PRODUCT ATTRIBUTE
        ====================================================================*/
        fetchProductAttribute: function () {
            var self = this;
            var domain = [];
            var ProductAttribute = new model.web.Model('product.attribute');
            return ProductAttribute.call('getProductAttribute',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            PRODUCT ATTRIBUTE VALUE
        ====================================================================*/
        fetchProductAttributeValue: function () {
            var self = this;
            var domain = [];
            var ProductAttributeValue = new model.web.Model('product.attribute.value');
            return ProductAttributeValue.call('getProductAttributeValue',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            STOCK MOVE
        ====================================================================*/
        fetchStockMove: function () {
            var self = this;
            var categ_ids = [];
            var company = $('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var category = self.$el.find('#current-category').val();
            var brand = self.$el.find('#current-brand').val();
            var attribute = self.$el.find('#current-attribute').val();
            var attribute_value = self.$el.find('#current-attribute-value').val();
            var location = self.$el.find('#current-location').val();
            var location2 = self.$el.find('#current-location2').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            var location_ids = _.flatten(_.map(self.StockLocation, function (item) {
                return item.id;
            }));
            var domain = [
                ['location_id', 'in',location_ids],
                ['location_dest_id', 'in',location_ids],
                ['state','=','done'],
            ];

            if(company && company != 9999999){
                domain.push(['company_id','=',parseFloat(company)]);
            }

            if(store && store != 9999999){

              domain.push('|',['location_id.store_id', '=', parseInt(store)],['location_dest_id.store_id', '=', parseInt(store)]);

            }

            if(brand && brand != 9999999){
                 domain.push(['product_id.product_brand_id','=',parseInt(brand)]);
            }

            if(location && location != 9999999){
                domain.push(['location_id','=',parseInt(location)]);
            }

            if(location2 && location2 != 9999999){
                domain.push(['location_dest_id','=',parseInt(location2)]);
            }

            if(date && date != 9999999){

                if(desde){
                    var date = desde.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['create_date','>=',date]);
                }

                if(hasta){
                    var date = hasta.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['create_date','<=',date]);
                }

                if(date == 'today'){
                  var today = moment().format('YYYY-MM-DD ');
                  domain.push(['create_date','like',today]);

                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD ');
                    domain.push(['create_date','like',yesterday]);
                }

                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['create_date','like',currentMonth]);
                }

                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['create_date','like',lastMonth]);
                }
            }

            if(category){
                var category_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return item.id == category || item.parent_id[0] == category;
                }), function(map){
                    return map.id;
                });
                var category_children_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });
                var category_grandchildren_ids = _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_children_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                }) ;
                categ_ids =  _.map(_.filter(self.ProductCategory,function (item) {
                    return _.contains(category_grandchildren_ids, item.parent_id[0]) || item.id == category;
                }), function(map){
                    return map.id;
                });
            };

            if(category && category != 9999999){
                domain.push(['product_id.categ_id','in',categ_ids]);
            }

            var attribute_ids = _.map(_.filter(self.ProductAttribute,function (item) {
                return item.id == attribute;
            }), function(map){
                return map.id;
            });

            var attribute_value_ids = _.map(_.filter(self.ProductAttributeValue,function (item) {
                return item.id == attribute_value;
            }), function(map){
                return map.id;
            });


            if(attribute && attribute != 9999999){
              domain.push(['product_id.attribute_line_ids.attribute_id', 'in', attribute_ids]);
            }

            if(attribute_value && attribute_value != 9999999){
              domain.push(['product_id.attribute_value_ids', 'in', attribute_value_ids]);
            }

            var StockMove = new model.web.Model('stock.move');
            return StockMove.call('getStockMove',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;

                /*=====================
                    LOCATION SELECTION
                =====================*/
                var location = self.$el.find('#current-location').empty();
                self.$el.find('#current-location').append('<option value="9999999">Todas las ubicaciones</option>');
                _.each(self.StockLocation,function(item){
                    self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                });

                var location2 = self.$el.find('#current-location2').empty();
                self.$el.find('#current-location2').append('<option value="9999999">Todas las ubicaciones</option>');
                _.each(self.StockLocation,function(item){
                    self.$el.find('#current-location2').append('<option value="' + item.id + '">' + item.display_name + '</option>');
                });

        },

        updateAttributeSelections: function () {
            var self = this;
            var attribute = self.$el.find('#current-attribute').val();
            if(attribute != 9999999){
                /*=============================
                    ATTRIBUTE VALUE SELECTION
                =============================*/
                var attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    if(parseFloat(attribute) == item.attribute_id[0]){
                        self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ATTRIBUTE VALUE SELECTION
                =============================*/
                var attribute_value = self.$el.find('#current-attribute-value').empty();
                self.$el.find('#current-attribute-value').append('<option value="9999999">Todos los valores de atributos</option>');
                _.each(self.ProductAttributeValue,function(item){
                    self.$el.find('#current-attribute-value').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var domain = true;
            var StockMove = self.StockMove;
            _.each(StockMove, function(item){

              data.push({
                /*=======================
                        IDS
                =======================*/
                id : item.id,
                /*=======================
                        INFO
                =======================*/

                picking_id : self.valorNull(item.picking_id.name),
                origin : self.valorNull(item.origin),
                partner_id : self.valorNull(item.partner_id.name),
                create_date :moment(item.create_date).format('DD-MM-YYYY'),
                product_id : item.product_id.display_name,
                location_id : item.location_id.complete_name,
                qty : item.product_uom_qty,
                location_dest_id : item.location_dest_id.complete_name,
              });
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var action = this.$el.find(e.target).val();
            var company = self.$el.find('#current-company').val();
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');
            var ResCompany = self.ResCompany[0];

            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
            }

            row.push({});

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Movimiento de Inventario.';
                var pdf_type = 'l';
                var pdf_name = 'movimiento_de_inventario_';
                var pdf_columnStyles = {
                  picking_id : {columnWidth: 30, halign:'left'},
                  origin : {columnWidth: 15, halign:'left'},
                  partner_id : {columnWidth: 40, halign:'left'},
                  create_date :{columnWidth: 16, halign:'left'},
                  product_id : {columnWidth: 65, halign:'left'},
                  location_id : {columnWidth: 50, halign:'left'},
                  qty : {columnWidth: 17, halign:'center'},
                  location_dest_id : {columnWidth: 50, halign:'left'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new reporting.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter,
                );
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('current-company').val();
          var store = self.$el.find('#current-store').val();
          var location = self.$el.find('#current-location').val();
          var location2 = self.$el.find('#current-location2').val();
          var brand = self.$el.find('#current-brand').val();
          var category = self.$el.find('#current-category').val();
          var attribute = self.$el.find('#current-attribute').val();
          var attribute_value = self.$el.find('#current-attribute-value').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company != 9999999){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }
          if(location && location != 9999999){
            var ResLocation = _.filter(self.StockLocation, function(item){
              return item.id == location;
            })
            filter.push({
              title: 'Ubicación de Origen',
              value: ResLocation[0].display_name,
            })
          }

          if(location2 && location2 != 9999999){
            var ResLocation2 = _.filter(self.StockLocation, function(item){
              return item.id == location2;
            })
            filter.push({
              title: 'Ubicación de Destino',
              value: ResLocation2[0].display_name,
            })
          }

          if(brand && brand != 9999999){
            var ProductBrand =  _.filter(self.ProductBrand,function (item) {
                return item.id == brand;
            });
            filter.push({
                 title: 'Marca',
                 value:  ProductBrand[0].name,
               });
          }

          if(category && category != 9999999){
            var ProductCategory =  _.filter(self.ProductCategory,function (item) {
                return item.id == category;
            });
            filter.push({
                 title: 'Categoría',
                 value:  ProductCategory[0].name,
               });
          }

          if(attribute && attribute != 9999999){
            var attr =  _.filter(self.ProductAttribute,function (item) {
                return item.id == attribute;
            });
            filter.push({
                 title: 'Atributo',
                 value: attr[0].name,
               });
          }

          if(attribute_value && attribute_value != 9999999){
            var attr_value =  _.filter(self.ProductAttributeValue,function (item) {
                return item.id == attribute_value;
            });
            filter.push({
                 title: 'Valor de Atributo',
                 value: attr_value[0].name,
               });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        },
    });
}
